package jmodeler;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * <p>Title: jModeler</p>
 * <p>Description: Create and View Besier curves and surfaces</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: Computer Aided Graphics Design</p>
 * @author Chirag Parmar
 * @version 1.0
 */

public class jModerlerFrame extends JFrame {
  JPanel contentPane;
  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenuFile = new JMenu();
  JMenuItem jMenuFileExit = new JMenuItem();
  JMenu jMenuHelp = new JMenu();
  JMenuItem jMenuHelpAbout = new JMenuItem();
  JToolBar jToolBar = new JToolBar();
  JButton jButton1 = new JButton();
  JButton jButton2 = new JButton();
  JButton jButton3 = new JButton();
  ImageIcon image1;
  ImageIcon image2;
  ImageIcon image3;
  JLabel statusBar = new JLabel();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel mainPanel = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JLabel partLabel = new JLabel();
  Viewer glViewer = null;
  JScrollPane GLScrollPane = new JScrollPane();
  JMenuItem jMenuCreateCurve = new JMenuItem();
  JMenuItem jMenuCreateSurface = new JMenuItem();
  jModelManager manager = null;
  CreateCurveFrame ccf = null;
  CreateSurfaceFrame csf = null;
  JButton toggleAxisViewButton = new JButton();
  JButton zoomInButton = new JButton();
  JButton zoomOutButton = new JButton();
  JButton zoomCancelButton = new JButton();
  JPanel objectListPanel = new JPanel();
  BorderLayout borderLayout3 = new BorderLayout();
  JScrollPane jScrollPane1 = new JScrollPane();
  JPopupMenu managerPopupMenu = new JPopupMenu();
  JMenuItem showMenuItem = new JMenuItem();
  JMenuItem renameMenuItem = new JMenuItem();
  JMenuItem deleteMenuItem = new JMenuItem();
  JList objectList = new JList();
  ManagerListModel objectListModel = new ManagerListModel();
  JMenuItem hideMenuItem = new JMenuItem();
  JPanel GLCanvasPanel = new JPanel();
  BorderLayout borderLayout4 = new BorderLayout();
  Border border1;
  JLabel jLabel1 = new JLabel();
  //Construct the frame
  public jModerlerFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    glViewer = new Viewer();
    //GLScrollPane.add(glViewer);
    GLCanvasPanel.add(glViewer,BorderLayout.CENTER);
    manager = new jModelManager(glViewer,objectListModel);
    ccf = new CreateCurveFrame(manager);
    csf = new CreateSurfaceFrame(manager);

  }

  //Component initialization
  private void jbInit() throws Exception  {
    image1 = new ImageIcon(jmodeler.jModerlerFrame.class.getResource("openFile.png"));
    image2 = new ImageIcon(jmodeler.jModerlerFrame.class.getResource("closeFile.png"));
    image3 = new ImageIcon(jmodeler.jModerlerFrame.class.getResource("help.png"));
    contentPane = (JPanel) this.getContentPane();
    border1 = BorderFactory.createEmptyBorder();
    contentPane.setLayout(borderLayout1);
    this.setResizable(false);
    this.setSize(new Dimension(790, 580));
    this.setTitle("jModeler");
    statusBar.setText(" jModeler Started");
    jMenuFile.setText("File");
    jMenuFileExit.setText("Exit");
    jMenuFileExit.addActionListener(new jModerlerFrame_jMenuFileExit_ActionAdapter(this));
    jMenuHelp.setText("Help");
    jMenuHelpAbout.setText("About");
    jMenuHelpAbout.addActionListener(new jModerlerFrame_jMenuHelpAbout_ActionAdapter(this));
    jButton1.setIcon(image1);
    jButton1.setToolTipText("Open File");
    jButton2.setIcon(image2);
    jButton2.setToolTipText("Close File");
    jButton3.setIcon(image3);
    jButton3.setToolTipText("Help");
    mainPanel.setLayout(borderLayout2);
    partLabel.setHorizontalAlignment(SwingConstants.CENTER);
    partLabel.setText("Bezier Curves & Surfaces");
    jMenuCreateCurve.setText("Create Curve");
    jMenuCreateCurve.addActionListener(new jModerlerFrame_jMenuCreateCurve_actionAdapter(this));
    jMenuCreateSurface.setText("Create Surface");
    jMenuCreateSurface.addActionListener(new jModerlerFrame_jMenuCreateSurface_actionAdapter(this));
    toggleAxisViewButton.setToolTipText("Show/Hide Axis");
    toggleAxisViewButton.setIcon(new ImageIcon(jModerlerFrame.class.getResource("axistrip16x16.png")));
    toggleAxisViewButton.setText("");
    toggleAxisViewButton.addActionListener(new jModerlerFrame_toggleAxisViewButton_actionAdapter(this));
    zoomInButton.setToolTipText("Zoom In");
    zoomInButton.setIcon(new ImageIcon(jModerlerFrame.class.getResource("zoomin16x16.png")));
    zoomInButton.setText("");
    zoomInButton.addActionListener(new jModerlerFrame_zoomInButton_actionAdapter(this));
    zoomOutButton.setToolTipText("Zoom Out");
    zoomOutButton.setIcon(new ImageIcon(jModerlerFrame.class.getResource("zoomout16x16.png")));
    zoomOutButton.setText("");
    zoomOutButton.addActionListener(new jModerlerFrame_zoomOutButton_actionAdapter(this));
    zoomCancelButton.setToolTipText("Zoom Reset");
    zoomCancelButton.setIcon(new ImageIcon(jModerlerFrame.class.getResource("zoomwin16x16.png")));
    zoomCancelButton.setText("");
    zoomCancelButton.addActionListener(new jModerlerFrame_zoomCancelButton_actionAdapter(this));
    objectListPanel.setLayout(borderLayout3);
    objectListPanel.setBorder(BorderFactory.createLineBorder(Color.black));
    objectListPanel.setPreferredSize(new Dimension(150, 0));
    showMenuItem.setText("Show");
    showMenuItem.addActionListener(new jModerlerFrame_showMenuItem_actionAdapter(this));
    renameMenuItem.setText("Rename");
    deleteMenuItem.setText("Delete");
    deleteMenuItem.addActionListener(new jModerlerFrame_deleteMenuItem_actionAdapter(this));
    managerPopupMenu.setInvoker(objectList);
    objectList.setModel(objectListModel);
    objectList.addMouseListener(new jModerlerFrame_objectList_mouseAdapter(this));
    hideMenuItem.setText("Hide");
    hideMenuItem.addActionListener(new jModerlerFrame_hideMenuItem_actionAdapter(this));
    GLScrollPane.setBorder(null);
    GLCanvasPanel.setLayout(borderLayout4);
    GLCanvasPanel.setBorder(BorderFactory.createLineBorder(Color.black));
    jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel1.setText("Object List");
    jToolBar.add(jButton1);
    jToolBar.add(jButton2);
    jToolBar.add(jButton3);
    jToolBar.add(toggleAxisViewButton, null);
    jToolBar.add(zoomInButton, null);
    contentPane.add(mainPanel,  BorderLayout.CENTER);
    contentPane.add(statusBar, BorderLayout.SOUTH);
    jMenuFile.add(jMenuCreateCurve);
    jMenuFile.add(jMenuCreateSurface);
    jMenuFile.add(jMenuFileExit);
    jMenuHelp.add(jMenuHelpAbout);
    jMenuBar1.add(jMenuFile);
    jMenuBar1.add(jMenuHelp);
    this.setJMenuBar(jMenuBar1);
    contentPane.add(jToolBar, BorderLayout.NORTH);
    mainPanel.add(partLabel,  BorderLayout.NORTH);
    mainPanel.add(objectListPanel,  BorderLayout.WEST);
    objectListPanel.add(jScrollPane1,  BorderLayout.CENTER);
    objectListPanel.add(jLabel1, BorderLayout.NORTH);
    mainPanel.add(GLCanvasPanel, BorderLayout.CENTER);
    GLCanvasPanel.add(GLScrollPane,  BorderLayout.CENTER);
    jScrollPane1.getViewport().add(objectList, null);
    jToolBar.add(zoomOutButton, null);
    jToolBar.add(zoomCancelButton, null);
    managerPopupMenu.add(showMenuItem);
    managerPopupMenu.add(hideMenuItem);
    managerPopupMenu.add(renameMenuItem);
    managerPopupMenu.add(deleteMenuItem);
  }

  //File | Exit action performed
  public void jMenuFileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  //Help | About action performed
  public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
    jModerlerFrame_AboutBox dlg = new jModerlerFrame_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.pack();
    dlg.show();
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      jMenuFileExit_actionPerformed(null);
    }
  }

  void jMenuCreateCurve_actionPerformed(ActionEvent e) {
    //CurveCreateFrame ccf = new CurveCreateFrame(manager);
    String curveStr = "Curve";
    int count = manager.getCurveCount();
    while( manager.getObjectListModel().contains( curveStr+count) ){
      count++;
      if( count > 10 ) break;
      System.out.println("Count is "+count);
    }
    Dimension dlgSize = ccf.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    ccf.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height)  / 2 + loc.y);
    ccf.pack();
    //ccf.resize(600,400);
    ccf.setCurveName( curveStr+count );
    ccf.show();

  }

  void toggleAxisViewButton_actionPerformed(ActionEvent e) {
    glViewer.setAxisVisible(!glViewer.getAxisVisible());
  }

  void zoomInButton_actionPerformed(ActionEvent e) {
    glViewer.zoomIn();
  }

  void zoomOutButton_actionPerformed(ActionEvent e) {
    glViewer.zoomOut();
  }

  void zoomCancelButton_actionPerformed(ActionEvent e) {
    glViewer.zoomReset();
  }

  void jMenuCreateSurface_actionPerformed(ActionEvent e) {
    String surfaceStr = "Surface";
    int count = manager.getSurfaceCount();
    while( manager.getObjectListModel().contains( surfaceStr+count ) ){
      count++;
      if (count>10) break;
      System.out.println("Count is "+count);
    }
    Dimension dlgSize = ccf.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    csf.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height)  / 2 + loc.y);
    csf.pack();
    csf.setSurfaceName( surfaceStr+count );
    csf.show();
  }

  void objectList_mousePressed(MouseEvent e) {
    //System.out.println(e.toString());
    if( e.isPopupTrigger() ){
      managerPopupMenu.show(e.getComponent(),e.getX(),e.getY());
    }
  }

  void objectList_mouseClicked(MouseEvent e) {

  }

  void objectList_mouseReleased(MouseEvent e) {

  }

  void showMenuItem_actionPerformed(ActionEvent e) {
    int[] indices = objectList.getSelectedIndices();
    for(int i=0; i<indices.length; i++){
      manager.objectSetVisible(indices[i],true);
    }
  }

  void hideMenuItem_actionPerformed(ActionEvent e) {
    int[] indices = objectList.getSelectedIndices();
    for(int i=0; i<indices.length; i++){
      manager.objectSetVisible(indices[i],false);
    }
  }

  void deleteMenuItem_actionPerformed(ActionEvent e) {
    int[] indices = objectList.getSelectedIndices();
    for(int i=0; i<indices.length; i++){
      manager.objectRemove(indices[i]);
    }
  }

}

class jModerlerFrame_jMenuFileExit_ActionAdapter implements ActionListener {
  jModerlerFrame adaptee;

  jModerlerFrame_jMenuFileExit_ActionAdapter(jModerlerFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuFileExit_actionPerformed(e);
  }
}

class jModerlerFrame_jMenuHelpAbout_ActionAdapter implements ActionListener {
  jModerlerFrame adaptee;

  jModerlerFrame_jMenuHelpAbout_ActionAdapter(jModerlerFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuHelpAbout_actionPerformed(e);
  }
}

class jModerlerFrame_jMenuCreateCurve_actionAdapter implements java.awt.event.ActionListener {
  jModerlerFrame adaptee;

  jModerlerFrame_jMenuCreateCurve_actionAdapter(jModerlerFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuCreateCurve_actionPerformed(e);
  }
}

class jModerlerFrame_toggleAxisViewButton_actionAdapter implements java.awt.event.ActionListener {
  jModerlerFrame adaptee;

  jModerlerFrame_toggleAxisViewButton_actionAdapter(jModerlerFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.toggleAxisViewButton_actionPerformed(e);
  }
}

class jModerlerFrame_zoomInButton_actionAdapter implements java.awt.event.ActionListener {
  jModerlerFrame adaptee;

  jModerlerFrame_zoomInButton_actionAdapter(jModerlerFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.zoomInButton_actionPerformed(e);
  }
}

class jModerlerFrame_zoomOutButton_actionAdapter implements java.awt.event.ActionListener {
  jModerlerFrame adaptee;

  jModerlerFrame_zoomOutButton_actionAdapter(jModerlerFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.zoomOutButton_actionPerformed(e);
  }
}

class jModerlerFrame_zoomCancelButton_actionAdapter implements java.awt.event.ActionListener {
  jModerlerFrame adaptee;

  jModerlerFrame_zoomCancelButton_actionAdapter(jModerlerFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.zoomCancelButton_actionPerformed(e);
  }
}

class jModerlerFrame_jMenuCreateSurface_actionAdapter implements java.awt.event.ActionListener {
  jModerlerFrame adaptee;

  jModerlerFrame_jMenuCreateSurface_actionAdapter(jModerlerFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuCreateSurface_actionPerformed(e);
  }
}

class jModerlerFrame_objectList_mouseAdapter extends java.awt.event.MouseAdapter {
  jModerlerFrame adaptee;

  jModerlerFrame_objectList_mouseAdapter(jModerlerFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void mousePressed(MouseEvent e) {
    adaptee.objectList_mousePressed(e);
  }
  public void mouseClicked(MouseEvent e) {
    adaptee.objectList_mouseClicked(e);
  }
  public void mouseReleased(MouseEvent e) {
    adaptee.objectList_mouseReleased(e);
  }
}

class jModerlerFrame_showMenuItem_actionAdapter implements java.awt.event.ActionListener {
  jModerlerFrame adaptee;

  jModerlerFrame_showMenuItem_actionAdapter(jModerlerFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.showMenuItem_actionPerformed(e);
  }
}

class jModerlerFrame_hideMenuItem_actionAdapter implements java.awt.event.ActionListener {
  jModerlerFrame adaptee;

  jModerlerFrame_hideMenuItem_actionAdapter(jModerlerFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.hideMenuItem_actionPerformed(e);
  }
}

class jModerlerFrame_deleteMenuItem_actionAdapter implements java.awt.event.ActionListener {
  jModerlerFrame adaptee;

  jModerlerFrame_deleteMenuItem_actionAdapter(jModerlerFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.deleteMenuItem_actionPerformed(e);
  }
}
