package jmodeler;

import javax.swing.*;
import java.awt.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;


/**
 * <p>Title: jModeler</p>
 * <p>Description: Create and View Besier curves and surfaces</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author (biswarup, chiragp, devesh, dharm, vikasj, jikku)@cse.iitb.ac.in
 * @version 1.0
 */

public class CurveCurvaturePanel extends JFrame {
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JButton jButton2 = new JButton();
  JPanel jPanel2 = new JPanel();
  JLabel jLabel1 = new JLabel();
  JPanel jPanel3 = new JPanel();
  JButton jButton3 = new JButton();
  JTextField jTextField1 = new JTextField();
  JSpinner jSpinner1 = new JSpinner();
  SpinnerModel sm = new SpinnerNumberModel(0.1,0.0,1.0,0.05);
  String s = null;
  Curve c = null;
  Viewer v= null;

  public CurveCurvaturePanel(Curve curve,Viewer viewer) {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    this.c = curve;
    this.v = viewer;
  }

  public void sets(String str){
    s = str;
    return;
  }
  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    jButton2.setText("Close");
    jButton2.addActionListener(new CurveCurvaturePanel_jButton2_actionAdapter(this));
    jLabel1.setText("Value of t");
    jButton3.setText("Find");
    jButton3.addActionListener(new CurveCurvaturePanel_jButton3_actionAdapter(this));
    jTextField1.setCaretPosition(0);
    jTextField1.setText("");
    jTextField1.setColumns(8);
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jButton3, null);
    jPanel1.add(jTextField1, null);
    this.getContentPane().add(jPanel2, BorderLayout.NORTH);
    jPanel2.add(jLabel1, null);
    jPanel2.add(jSpinner1, null);
    this.getContentPane().add(jPanel3, BorderLayout.SOUTH);
    jPanel3.add(jButton2, null);
    jSpinner1.setModel(sm);
    jSpinner1.setPreferredSize(new Dimension(50,20));
    jSpinner1.setVerifyInputWhenFocusTarget(true);

  }

  void jButton2_actionPerformed(ActionEvent e) {
    c.showp= false;
    this.setVisible(false);
    v.postRedisplay();
  }

  void jButton3_actionPerformed(ActionEvent e) {
    int size = c.ctrPt.size();
    Point3d[] pt = new Point3d[size];

      for(int j=0;j<size;j++){
        Point3d p3d = (Point3d)c.ctrPt.get(j);
        pt[j] = new Point3d(p3d.getx(),p3d.gety(),p3d.getz());
      }

    double t = ((Double)this.jSpinner1.getValue()).doubleValue();
      c.showp = true;
      c.p = null;
      c.makep(t);
      System.out.println("The value of t = "+t);
      double curvatureCurve = Curvature.computeCurvature(pt,t,pt.length);
      System.out.println("The curvature is : "+curvatureCurve);
      String s = String.valueOf(curvatureCurve);
      this.sets(s);
    jTextField1.setText(s);
    v.postRedisplay();
  }

}

class CurveCurvaturePanel_jButton2_actionAdapter implements java.awt.event.ActionListener {
  CurveCurvaturePanel adaptee;

  CurveCurvaturePanel_jButton2_actionAdapter(CurveCurvaturePanel adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton2_actionPerformed(e);
  }
}

class CurveCurvaturePanel_jButton3_actionAdapter implements java.awt.event.ActionListener {
  CurveCurvaturePanel adaptee;

  CurveCurvaturePanel_jButton3_actionAdapter(CurveCurvaturePanel adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton3_actionPerformed(e);
  }
}
