package jmodeler;

import javax.swing.*;
import java.awt.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;

/**
 * <p>Title: jModeler</p>
 * <p>Description: Create and View Besier curves and surfaces</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author (biswarup, chiragp, devesh, dharm, vikasj, jikku)@cse.iitb.ac.in
 * @version 1.0
 */

public class IsoParametricFrame extends JFrame {
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JButton jButton1 = new JButton();
  JButton jButton2 = new JButton();
  JPanel jPanel2 = new JPanel();
  JRadioButton jRadioButton1 = new JRadioButton();
  JRadioButton jRadioButton2 = new JRadioButton();
  VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();
  SpinnerModel sm = new SpinnerNumberModel(5,2,20,1);
  JPanel jPanel3 = new JPanel();
  JLabel jLabel1 = new JLabel();
  JSpinner jSpinner1 = new JSpinner();
  Surface s = null;
  Viewer viewer = null;
  ButtonGroup buttonGroup1 = new ButtonGroup();


  public IsoParametricFrame(Surface sur, Viewer v) {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    s = sur;
    viewer = v;
  }
  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    jButton1.setText("Ok");
    jButton1.addActionListener(new IsoParametricFrame_jButton1_actionAdapter(this));
    jButton2.setText("Close");
    jButton2.addActionListener(new IsoParametricFrame_jButton2_actionAdapter(this));
    jPanel2.setLayout(verticalFlowLayout1);
    jRadioButton1.setText("wrt u");
    jRadioButton2.setText("wrt v");
    jLabel1.setText("No. of Lines");
    this.getContentPane().add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(jButton1, null);
    jPanel1.add(jButton2, null);
    this.getContentPane().add(jPanel2,  BorderLayout.NORTH);
    jPanel2.add(jRadioButton1, null);
    jPanel2.add(jRadioButton2, null);
    this.getContentPane().add(jPanel3, BorderLayout.CENTER);
    jPanel3.add(jLabel1, null);
    jPanel3.add(jSpinner1, null);
    jSpinner1.setModel(sm);
    jSpinner1.setPreferredSize(new Dimension(50,20));
    jSpinner1.setVerifyInputWhenFocusTarget(true);
    buttonGroup1.add(jRadioButton1);
    buttonGroup1.add(jRadioButton2);

  }

  void jButton1_actionPerformed(ActionEvent e) {
    s.showIsoLines = false;
    int n = ( (Integer)this.jSpinner1.getValue()).intValue();
    int out = 0;
    if(jRadioButton1.isSelected()){
      out = 0;
    }
    else if(jRadioButton2.isSelected()){
      out = 1;
    }
    else out=0;


    s.setIsoparametric(n,out);  // 0 == u, 1 == v
      viewer.postRedisplay();
  }

  void jButton2_actionPerformed(ActionEvent e) {
    s.showIsoLines = false;
    s.filltriangles = true;
    this.setVisible(false);
    viewer.postRedisplay();
  }

}

class IsoParametricFrame_jButton1_actionAdapter implements java.awt.event.ActionListener {
  IsoParametricFrame adaptee;

  IsoParametricFrame_jButton1_actionAdapter(IsoParametricFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton1_actionPerformed(e);
  }
}

class IsoParametricFrame_jButton2_actionAdapter implements java.awt.event.ActionListener {
  IsoParametricFrame adaptee;

  IsoParametricFrame_jButton2_actionAdapter(IsoParametricFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton2_actionPerformed(e);
  }
}
