package jmodeler;

/**
 * <p>Title: jModeler</p>
 * <p>Description: Create and View Bezier curves and surfaces</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: Computer Aided Graphics Design</p>
 * @author (biswarup, chiragp, devesh, dharm, vikasj, jikku)@cse.iitb.ac.in
 * @version 1.0
 */

public class Point3d
    extends Object {
  double x, y, z;
  public Point3d(double _x, double _y, double _z) {
    x = _x;
    y = _y;
    z = _z;
  }

//copy constructor
  public Point3d(Point3d P) {
    this(P.getx(), P.gety(), P.getz());
  }

  public double getx() {
    return x;
  }

  public double gety() {
    return y;
  }

  public double getz() {
    return z;
  }

  public String toString(){
    String s = new String();
    s = "X = "+x+",Y = "+y+",Z = "+z;
    return s;
  }

  /**
   * normalize
   *
   * @return Point3d
   */
  public Point3d normalize() {
    double d = Math.sqrt(x*x+y*y+z*z);
    return new Point3d(x/d,y/d,z/d);
  }
}
