package jmodeler;

import java.io.*;
import java.util.*;

import java.awt.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author (biswarup, chiragp, devesh, dharm, vikasj, jikku)@cse.iitb.ac.in
 * @version 1.0
 */

public class Surface {

  //Vector ctrPt = new Vector();
  Vector bBox = new Vector();

  double segLen;
  int finished = 0; //finished == 1 means Curve formation complete
  boolean visible = true;
  boolean showControlPts = false;
  boolean showIsoLines = false;
  boolean filltriangles = true;
  int isoLines = 0;
  int whichLines = 0;
  Point3d p = null; //a point to be shown by the curvature, tangent etc.
  boolean showp = false;
  String name = null;
  double u,v; //for tangent
 boolean drawTangent = false;

  java.awt.Color color;
  private boolean removed = false;;

  public void toggleshowControlPts(){
    showControlPts = !showControlPts;
  }

 public void setuv(double u, double v){
   this.u = u;
   this.v = v;
 }
  public void fillTriangles(){
    filltriangles = !filltriangles;
  }
  public void setIsoparametric(int n,int p){
     showIsoLines = !showIsoLines;
     isoLines = n;
     whichLines = p; // whichLine == 0 means u and 1 means v
     if(showIsoLines) filltriangles= false;
     else filltriangles = true;
  }


  public Surface(String _name,String file, java.awt.Color _color, double _segLen) throws FileNotFoundException,IOException{
    java.io.BufferedReader reader = null;
    Vector ctrPt = null;
    reader = new java.io.BufferedReader(new FileReader(file));

    String line = "";
    String token = "";
    int m = 0, old_m = 0;
    int n = 0;

    while ( (line = reader.readLine()) != null) {
      n++;
      StringTokenizer st = new StringTokenizer(line, " ");
      if (n == 2) {
        old_m = m;
      }
      else {
        if (old_m != m) {
          //System.err.println("File Format BAD: No. of coloums not same");
          throw new FileNotFoundException("File Format BAD: No. of coloums not same");
        }
      }
      m = 0;
      ctrPt = new Vector();
      while ( st.hasMoreTokens() ) {
        double x = Double.parseDouble(st.nextToken());
        double y = Double.parseDouble(st.nextToken());
        double z = Double.parseDouble(st.nextToken());
        Point3d p = new Point3d(x, y, z);
        ctrPt.add(new Point3d(x, y, z));
        m++;
      }
      bBox.add(ctrPt);
      //ctrPt.clear();

    }

    reader.close();

    //color
    color = _color;
    //segment length
    segLen = _segLen;
    name = _name;
    finished = 1;
    return;

  }

  public boolean equals(Object o){
    String s = o.toString();
    return s.equals(name);
  }

  public String toString(){
    return new String(name);
  }

  public boolean isFormed() {
    if (this.finished == 1) {
      return true;
    }
    else {
      return false;
    }
  }

  public Color getColor() {
    return this.color;
  }

  public double getSeglength() {
    return this.segLen;
  }

  /*public Point3d[] getControlPts() {
    return (Point3d[]) ctrPt.toArray();
  }*/

  public long factorial(long x) {
    int output = 1;
    for (int i = 1; i <= x; i++) {
      output = output * i;
    }
    return output;
    /*if(x < 0) { throw new IllegalArgumentException("Argument less than zero"); }
         return (x <= 1) ? 1 : (x * factorial(x-1));
     */
  }

  public void makep(double u, double v){
    double tempx = 0, tempy = 0, tempz = 0;

    double Bu = 0.0;
    double Bv = 0.0;
    int m = ((Vector)bBox.get(0)).size();
    int n = bBox.size();

    for (int j = 0; j < n; j++) {
            Object[] temp = ((Vector) bBox.get(j)).toArray();
            Point3d[] point = new Point3d[temp.length];
            for (int i = 0; i < temp.length; i++) {
              point[i] = (Point3d) temp[i];
            }
            Bv = (factorial( (long) (n-1)) /
                  (factorial( (long) j) * factorial( (long) (n -1- j))))
                * Math.pow(v, j) * Math.pow(1 - v, n -1- j);
            for (int i = 0; i < m; i++) {
              Bu = (factorial( (long) (m-1)) /
                    (factorial( (long) i) * factorial( (long) (m -1- i))))
                  * Math.pow(u, i) * Math.pow(1 - u, m -1- i);

              tempx += point[i].x * Bu * Bv;
              tempy += point[i].y * Bu * Bv;
              tempz += point[i].z * Bu * Bv;
            }
          }

    p = new Point3d(tempx,tempy,tempz);
  }

  public Point3d calculateAt(double u, double v){
    double tempx = 0, tempy = 0, tempz = 0;

    double Bu = 0.0;
    double Bv = 0.0;
    int m = ((Vector)bBox.get(0)).size();
    int n = bBox.size();

    for (int j = 0; j < n; j++) {
            Object[] temp = ((Vector) bBox.get(j)).toArray();
            Point3d[] point = new Point3d[temp.length];
            for (int i = 0; i < temp.length; i++) {
              point[i] = (Point3d) temp[i];
            }
            Bv = (factorial( (long) (n-1)) /
                  (factorial( (long) j) * factorial( (long) (n -1- j))))
                * Math.pow(v, j) * Math.pow(1 - v, n -1- j);
            for (int i = 0; i < m; i++) {
              Bu = (factorial( (long) (m-1)) /
                    (factorial( (long) i) * factorial( (long) (m -1- i))))
                  * Math.pow(u, i) * Math.pow(1 - u, m -1- i);

              tempx += point[i].x * Bu * Bv;
              tempy += point[i].y * Bu * Bv;
              tempz += point[i].z * Bu * Bv;
            }
          }

    return (new Point3d(tempx,tempy,tempz));
  }


  public Point3d[] generate_u(){
         double udiv = (double)isoLines;
         double vdiv = 1.0f/segLen;

         int m = ((Vector)bBox.get(0)).size();
         int n = bBox.size();
         double u = 0.0, v = 0.0;
         double tempx = 0, tempy = 0, tempz = 0;

         double Bu = 0.0;
         double Bv = 0.0;
         Point3d[][] finalP = new Point3d[ (int) udiv][ (int) vdiv+1];
         Point3d[] output = new Point3d[(int)((udiv)*(vdiv+1))];
         try {
           for (int a = 0; a < (int) udiv; a++) {
             for (int b = 0; b <= (int) vdiv; b++) {
               tempx = 0;
               tempy = 0;
               tempz = 0;
               for (int j = 0; j < n; j++) {
                 Object[] temp = ((Vector) bBox.get(j)).toArray();
                 Point3d[] point = new Point3d[temp.length];
                 for (int q = 0; q < temp.length; q++) {
                   point[q] = (Point3d) temp[q];
                 }
                 Bv = (factorial( (long) (n-1)) /
                       (factorial( (long) j) * factorial( (long) (n -1- j))))
                     * Math.pow(v, j) * Math.pow(1 - v, n -1- j);
                 for (int i = 0; i < m; i++) {
                   Bu = (factorial( (long) (m-1)) /
                       (factorial( (long) i) * factorial( (long) (m -1- i))))
                     * Math.pow(u, i) * Math.pow(1 - u, m -1- i);

                 tempx += point[i].x * Bu * Bv;
                 tempy += point[i].y * Bu * Bv;
                 tempz += point[i].z * Bu * Bv;
               }
             }
             finalP[a][b] = new Point3d(tempx, tempy, tempz);
             v += segLen;
           }
           v = 0.0;
           u += (double)(1.0f/(isoLines-1));
         }
         int w=0;
         for (int i = 0; i < udiv; i++) {
           for (int j = 0; j <= vdiv; j++) {
             output[w] = finalP[i][j] ;
             w++;
           }
         }

       }
       catch (Exception e) {
         e.printStackTrace();
       }
       return output;
     }

     public Point3d[] generate_v(){

       double vdiv = (double)isoLines;
       double udiv = 1.0f/segLen;

       int m = ((Vector)bBox.get(0)).size();
       int n = bBox.size();
       double u = 0.0, v = 0.0;
       double tempx = 0, tempy = 0, tempz = 0;

       double Bu = 0.0;
       double Bv = 0.0;
       Point3d[][] finalP = new Point3d[ (int) udiv+1][ (int) vdiv];
       Point3d[] output = new Point3d[(int)((udiv+1)*(vdiv))];
       try {
         for (int a = 0; a <= (int) udiv; a++) {
           for (int b = 0; b < (int) vdiv; b++) {
             tempx = 0;
             tempy = 0;
             tempz = 0;
             for (int j = 0; j < n; j++) {
               Object[] temp = ((Vector) bBox.get(j)).toArray();
               Point3d[] point = new Point3d[temp.length];
               for (int q = 0; q < temp.length; q++) {
                 point[q] = (Point3d) temp[q];
               }
               Bv = (factorial( (long) (n-1)) /
                     (factorial( (long) j) * factorial( (long) (n -1- j))))
                   * Math.pow(v, j) * Math.pow(1 - v, n -1- j);
               for (int i = 0; i < m; i++) {
                 Bu = (factorial( (long) (m-1)) /
                     (factorial( (long) i) * factorial( (long) (m -1- i))))
                   * Math.pow(u, i) * Math.pow(1 - u, m -1- i);

               tempx += point[i].x * Bu * Bv;
               tempy += point[i].y * Bu * Bv;
               tempz += point[i].z * Bu * Bv;
             }
           }
           finalP[a][b] = new Point3d(tempx, tempy, tempz);
           v += (double)(1.0f/(isoLines-1));
         }
         v = 0.0;
         u += segLen;
       }
       int w=0;
       for (int i = 0; i <= udiv; i++) {
         for (int j = 0; j < vdiv; j++) {
           output[w] = finalP[i][j] ;
           w++;
         }
       }
     }
     catch (Exception e) {
       e.printStackTrace();
     }
     return output;
   }




/*     public Point3d[] generate_v(){
       double vdiv = (double)isoLines;
       double udiv = 1.0f/segLen;

       int m = ((Vector)bBox.get(0)).size();
       int n = bBox.size();
       double u = 0.0, v = 0.0;
       double tempx = 0, tempy = 0, tempz = 0;

       double Bu = 0.0;
       double Bv = 0.0;
       Point3d[][] finalP = new Point3d[ (int) vdiv][ (int) udiv];
       Point3d[] output = new Point3d[(int)((vdiv)*(udiv))];
       try {
         for (int b = 0; b < (int) vdiv; b++) {
           for (int a = 0; a < (int) udiv; a++) {
             tempx = 0;
             tempy = 0;
             tempz = 0;
             for (int i = 0; i < m; i++) {
               Object[] temp = ((Vector) bBox.get(i)).toArray();
               Point3d[] point = new Point3d[temp.length];
               for (int q = 0; q < temp.length; q++) {
                 point[q] = (Point3d) temp[q];
               }
               Bu = (factorial( (long) (m-1)) /
                     (factorial( (long) i) * factorial( (long) (m -1- i))))
                   * Math.pow(u, i) * Math.pow(1 - u, m -1- i);

               for (int j = 0; j < n; j++) {
                 Bv = (factorial( (long) (n-1)) /
                     (factorial( (long) j) * factorial( (long) (n -1- j))))
                   * Math.pow(v, j) * Math.pow(1 - v, n -1- j);
                 tempx += point[j].x * Bu * Bv;
                 tempy += point[j].y * Bu * Bv;
                 tempz += point[j].z * Bu * Bv;
               }
             }
             finalP[b][a] = new Point3d(tempx, tempy, tempz);
             u += segLen;
           }
         u = 0.0;
         v += (double)1.0f/isoLines;
       }
       int w=0;
       for (int j = 0; j < vdiv; j++) {
         for (int i = 0; i < udiv; i++) {
           output[w] = finalP[j][i] ;
           w++;
         }
       }

     }

     catch (Exception e) {
       e.printStackTrace();
     }
     return output;
   }*/

   public double bernstein_val(int n1,int i1,double t){
     return (( factorial(n1) /( factorial (i1) * factorial(n1-i1)) * Math.pow(t,i1) * Math.pow(1-t,n1-i1)));
   }

   public double diff(int num,int i2,double t){
     return (num * (bernstein_val(num-1,i2-1,t) - bernstein_val(num-1,i2,t)));
   }

   public Vector tangentPlane(double u, double v){
     int m = ((Vector) bBox.get(0)).size(); // u_degree = m -1 ;
     int n = bBox.size(); // v_degree = n - 1;
     Point3d f_u = new Point3d(0,0,0);
     Point3d f_v = new Point3d(0,0,0);
     //compute f_u
     for(int j=0;j<n;j++){
       Point3d tmp = new Point3d(0,0,0);
       for(int i=0;i<m;i++){
         double diff1 = diff(m-1,i,u);
         tmp.x += ((Point3d) ((Vector) bBox.elementAt(j)).elementAt(i)).x  * diff1;
         tmp.y += ((Point3d) ((Vector) bBox.elementAt(j)).elementAt(i)).y  * diff1;
         tmp.z += ((Point3d) ((Vector) bBox.elementAt(j)).elementAt(i)).z  * diff1;
       }
       double ber_val = bernstein_val(n-1,j,v);
       tmp.x *= ber_val;
       tmp.y *= ber_val;
       tmp.z *= ber_val;
       f_u.x += tmp.x; f_u.y += tmp.y; f_u.z += tmp.z;
       double denom = Math.sqrt( Math.pow(f_u.x,2) + Math.pow(f_u.y,2) + Math.pow(f_u.z,2));
       f_u.x /= denom; f_u.y /= denom; f_u.z /= denom;
     }


     //compute f_v
     for(int i=0;i<m;i++){
       Point3d tmp = new Point3d(0,0,0);
       for(int j=0;j<n;j++){
         double diff1 = diff(n-1,j,v);
         tmp.x += ((Point3d) ((Vector) bBox.elementAt(j)).elementAt(i)).x  * diff1;
         tmp.y += ((Point3d) ((Vector) bBox.elementAt(j)).elementAt(i)).y  * diff1;
         tmp.z += ((Point3d) ((Vector) bBox.elementAt(j)).elementAt(i)).z  * diff1;
       }
       double ber_val = bernstein_val(m-1,i,u);
       tmp.x *= ber_val;
       tmp.y *= ber_val;
       tmp.z *= ber_val;
       f_v.x += tmp.x; f_v.y += tmp.y; f_v.z += tmp.z;
       double denom = Math.sqrt( Math.pow(f_v.x,2) + Math.pow(f_v.y,2) + Math.pow(f_v.z,2));
       f_v.x /= denom; f_v.y /= denom; f_v.z /= denom;
     }

     Vector u_v_vector = new Vector();
     u_v_vector.add(f_u); u_v_vector.add(f_v);
     return u_v_vector;
   }



   public Triangle3d[] generateRenderingTriangles() {
     double itr = (double) (1.0 / segLen);

     int m = ((Vector)bBox.get(0)).size();
     int n = bBox.size();
     double u = 0.0, v = 0.0;
     double tempx = 0, tempy = 0, tempz = 0;

     double Bu = 0.0;
     double Bv = 0.0;
     Point3d[][] finalP = new Point3d[ (int) (itr+1)][ (int) (itr+1)];
     Vector output = new Vector();
     try {
       for (int a = 0; a <= (int) itr; a++) {
         for (int b = 0; b <= (int) itr; b++) {
           tempx = 0;
           tempy = 0;
           tempz = 0;
           for (int j = 0; j < n; j++) {
             Object[] temp = ((Vector) bBox.get(j)).toArray();
             Point3d[] point = new Point3d[temp.length];
             for (int i = 0; i < temp.length; i++) {
               point[i] = (Point3d) temp[i];
             }
             Bv = (factorial( (long) (n-1)) /
                   (factorial( (long) j) * factorial( (long) (n -1- j))))
                 * Math.pow(v, j) * Math.pow(1 - v, n -1- j);
             for (int i = 0; i < m; i++) {
               Bu = (factorial( (long) (m-1)) /
                     (factorial( (long) i) * factorial( (long) (m -1- i))))
                   * Math.pow(u, i) * Math.pow(1 - u, m -1- i);

               tempx += point[i].x * Bu * Bv;
               tempy += point[i].y * Bu * Bv;
               tempz += point[i].z * Bu * Bv;
             }
          }
          finalP[a][b] = new Point3d(tempx, tempy, tempz);
          v += segLen;
        }
        v = 0.0;
        u += segLen;
      }

      for (int i = 0; i <= (itr - 1); i++) {
        for (int j = 0; j <= (itr - 1); j++) {
          output.add(new Triangle3d(finalP[i+1][j+1], finalP[i][j + 1],
                                    finalP[i][j]));
          output.add(new Triangle3d(finalP[i][j], finalP[i + 1][j],
                                    finalP[i + 1][j + 1]));
        }
      }
    }
    catch (Exception e) {
      e.printStackTrace();
    }

    Triangle3d ans[] = new Triangle3d[output.size()];
    for(int i=0;i<ans.length;i++){
      ans[i] = (Triangle3d) output.get(i);
    }
    return ans;
  }
  public boolean isVisible() {
    return visible;
  }
  public void setVisible(boolean visible) {
    this.visible = visible;
  }
  public String getName() {
    return name;
  }
  public void setName(String name) {
    this.name = name;
  }

  /**
   * setRemoved
   */
  public void setRemoved() {
    removed = true;
  }

  public boolean isRemoved(){
    return removed;
  }
}
