package jmodeler;

import java.util.*;
import javax.swing.*;
import java.awt.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * <p>Title: jModeler</p>
 * <p>Description: Create and View Bezier curves and surfaces</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: Computer Aided Graphics Design</p>
 * @author (biswarup, chiragp, devesh, dharm, vikasj, jikku)@cse.iitb.ac.in
 * @version 1.0
 */

public class jModelManager extends JFrame{
  Vector curves = new Vector();
  Vector surfaces = new Vector();
  Viewer viewer = null;
  ManagerListModel objectListModel = null;
  CurveCurvaturePanel ccp = null;
  SurfaceCurvatureFrame scf = null;
  double curvatureCurve=0.0;
  double[] curvature = new double[2];
  boolean changed = false;
  public jModelManager(Viewer v) {
    this.viewer = v;
  }

  public jModelManager(Viewer v,ManagerListModel model) {
    this.viewer = v;
    this.objectListModel = model;

  }

  public void addCurve(Curve c){
    curves.add(c);
    changed = true;
    viewer.addCurve(c);
    objectListModel.addElement(c);
  }

  public void isoparametric(int i){
    System.out.println("isoparametric lines are drawn");
      Object o = objectListModel.get(i);
      if( o == null ) return;
      if( o instanceof Curve){
      //a panel will open here saying that there are no isoparametric lines for curves
      //  c.setVisible(b);
      }else if( o instanceof Surface ){
        Surface s = (Surface) o;
        //a new panel will open asking user for
        // 1. wrt u/v (toggle button)
        // 2. number of parametric lines

        //a bool variable inside Surface says taht the lines are drawn or not
        // so that will change that variable + one more int variable stating the no of lines is set.
        IsoParametricFrame ipf = new IsoParametricFrame(s,viewer);
        ipf.pack();
        ipf.show();

        }
      viewer.postRedisplay();
    }

    public void drawTangent(int i){
    Object o = objectListModel.get(i);
      if( o == null ) return;
      if( o instanceof Curve){
        Curve c = (Curve) o;
        CurveTangentPanel ctp = new CurveTangentPanel(c,viewer);

        ctp.pack();
        ctp.show();

    }
    else if(o instanceof Surface){
      Surface s = (Surface) o;
      SurfaceTangentPanel stp = new SurfaceTangentPanel(s,viewer);
      stp.pack();
      stp.show();
    }
    viewer.postRedisplay();
  }
  public void objectSetVisible(int i,boolean b){
    Object o = objectListModel.get(i);
    if( o == null ) return;
    if( o instanceof Curve){
      Curve c = (Curve) o;
      c.setVisible(b);
    }else if( o instanceof Surface ){
      Surface s = (Surface) o;
      s.setVisible(b);
    }
    viewer.postRedisplay();
  }

  public void objectFilltriangles(int i){
    Object o = objectListModel.get(i);
    if( o == null ) return;
    if( o instanceof Surface){
      Surface s = (Surface) o;
      s.fillTriangles();
    }
    viewer.postRedisplay();
  }

  public void objectCurvature(int i){
    Object o = objectListModel.get(i);
    if ( o == null) return;
    if(o instanceof Curve){
      //a new panel opens asking user for "t"

      Curve c = (Curve) o;
      ccp = new CurveCurvaturePanel(c,viewer);
      Dimension dlgSize = ccp.getPreferredSize();
      Dimension frmSize = getSize();
      Point loc = getLocation();
      ccp.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height)  / 2 + loc.y);
      ccp.pack();


      ccp.show();


      int size = c.ctrPt.size();
      Point3d[] pt = new Point3d[size];

      for(int j=0;j<size;j++){
        Point3d p3d = (Point3d)c.ctrPt.get(j);
        pt[j] = new Point3d(p3d.getx(),p3d.gety(),p3d.getz());
      }
      double t = ((Double)ccp.jSpinner1.getValue()).doubleValue();
      c.showp = true;

      c.makep(t);
      curvatureCurve = Curvature.computeCurvature(pt,t,pt.length);
      System.out.println("The curvature is : "+curvatureCurve);
      String s = String.valueOf(curvatureCurve);
      ccp.sets(s);

      //return;
    }
    else if (o instanceof Surface){
      //a new panel opens asking user for "u" and "v"
      Surface s = (Surface) o;
      scf = new SurfaceCurvatureFrame(s,viewer);

      Dimension dlgSize = scf.getPreferredSize();
      Dimension frmSize = getSize();
      Point loc = getLocation();
      scf.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height)  / 2 + loc.y);
      scf.pack();


      scf.show();



      //return;

    }
    viewer.postRedisplay();
  }

  public void controlPts(int i){
    Object o = objectListModel.get(i);
    if( o == null ) return;
    if( o instanceof Curve){
      Curve c = (Curve) o;
      c.toggleshowControlPts();

    }else if( o instanceof Surface ){
      Surface s = (Surface) o;
      s.toggleshowControlPts();
    }
    viewer.postRedisplay();
  }


  public void objectRemove(int i){
    Object o = objectListModel.get(i);
    if( o == null ) return;
    if( o instanceof Curve){
      Curve c = (Curve) o;
      c.setRemoved();
      objectListModel.remove(i);
      curves.remove(i);
    }else if( o instanceof Surface ){
      Surface s = (Surface) o;
      s.setRemoved();
      objectListModel.remove(i);
      surfaces.remove(i);
    }
    viewer.postRedisplay();
  }

  public void addSurface(Surface s){
    surfaces.add(s);
    changed = true;
    viewer.addSurface(s);
    objectListModel.addElement(s);
  }

  public void updateViewer(){
    if( changed ){

    }
  }
  public ManagerListModel getObjectListModel() {
    return objectListModel;
  }
  public void setObjectListModel(ManagerListModel objectListModel) {
    this.objectListModel = objectListModel;
  }
  public Viewer getViewer() {
    return viewer;
  }
  public void setViewer(Viewer viewer) {
    this.viewer = viewer;
  }

  /**
   * getCurveCount
   *
   * @return int
   */
  public int getCurveCount() {
    return curves.size();
  }

  /**
   * getSurfaceCount
   *
   * @return int
   */
  public int getSurfaceCount() {
    return surfaces.size();
  }
}
