package jmodeler;
import java.io.*;
import java.awt.*;
import java.util.StringTokenizer;
import java.util.*;
import java.math.*;
public final class Curvature
{
	//int numCtrlPoints = 8,i;
	//Point3d[] ctrlPoints = new Point3d[numCtrlPoints];
	/*public static void main(String[] args)
	{
		int numCtrlPoints = 8, i;
		Point3d[] ctrlPoints = new Point3d[numCtrlPoints];
		for (i = 0; i < numCtrlPoints; i++)
		{
			ctrlPoints[i] = new Point3d(20 * Math.random(), 20 * Math.random(), 20 * Math.random());
		}
		for (i = 0; i < numCtrlPoints; i++)
		{
			System.out.println(" " + ctrlPoints[i].x + "  " + ctrlPoints[i].y
					+ "  " + ctrlPoints[i].z);
		}
		System.out.println(exp(3.0,-2));

		System.out.println("B : " + B(3,0,0.5) + "  " + B(3,1,0.5) + "  " + B(3,2,0.5) + "  " + B(3,3,0.5));
		System.out.println("dBdt : " + dBdt(3,0,0.5) + "  " + dBdt(3,1,0.5) + "  " + dBdt(3,2,0.5) + "  " + dBdt(3,3,0.5));
		System.out.println("d2Bdt2 : " + d2Bdt2(3,0,0.5) + "  " + d2Bdt2(3,1,0.5) + "  " + d2Bdt2(3,2,0.5) + "  " + d2Bdt2(3,3,0.5));

		System.out.println("dRdt : " + dRdt(3,0,0.5) + "  " + dRdt(3,1,0.5) + "  " + dRdt(3,2,0.5) + "  " + dRdt(3,3,0.5));
		System.out.println("d2Rdt2 : " + d2Rdt2(3,0,0.5) + "  " + d2Rdt2(3,1,0.5) + "  " + d2Rdt2(3,2,0.5) + "  " + d2Rdt2(3,3,0.5));

		System.out.println(computeCurvature(ctrlPoints,0.5,8));
	}*/

	public static double computeCurvature(Point3d[] ctrlPoints, double t,
                                              int numCtrlPoints) {
          //if numCtrlPoints = 3, there are 3 control points, 0, 1 and 2.
          /*
              Computes curvature of the curve represented by the control points[]
           */
          double rtx=0.0, rty=0.0, rtz=0.0, rttx=0.0, rtty=0.0, rttz=0.0, st=0.0, stt=0.0, output=0.0;
          Point3d rt, rtt;
		int j,n;
		n = numCtrlPoints - 1;

		for(j=0; j<numCtrlPoints; j++)
		{

                  rtx += ctrlPoints[j].getx() * dRdt(n,j,t);

                  rty += ctrlPoints[j].gety() * dRdt(n,j,t);

                  rtz += ctrlPoints[j].getz() * dRdt(n,j,t);

                  rttx += ctrlPoints[j].getx() * d2Rdt2(n,j,t);
//                  System.out.println("thisx : " + (ctrlPoints[j].getx() * d2Rdt2(n,j,t)) + "nowx = " + rttx);

                  rtty += ctrlPoints[j].gety() * d2Rdt2(n,j,t);

                  rttz += ctrlPoints[j].getz() * d2Rdt2(n,j,t);


		}
//		System.out.println("rttxyz = " + rttx + "  " + rtty + "  " + rttz);
		rt = new Point3d(rtx, rty, rtz);
		rtt = new Point3d(rttx, rtty, rttz);
		output = dotP(rt,rt) / Math.sqrt(dotP(rtt,rtt) - (dotP(rt,rtt)*dotP(rt,rtt))/dotP(rt,rt));
//		System.out.println("rt = " + rt.getx() + "  " + rt.gety() + "  " + rt.getz());
//		System.out.println("rtt = " + rtt.getx() + "  " + rtt.gety() + "  " + rtt.getz());
//		System.out.println("rtt.rtt=" + dotP(rtt,rtt) + "  rt.rtt=" +  dotP(rt,rtt) + "  rt.rt=" + dotP(rt,rt));
  //              System.out.println("Returning NOW");
		return output;

	}

	public static double[] computeCurvature(Point3d[][] ctrlPoints, double u, double v, int
	numCtrlPointsRow, int numCtrlPointsCol)//computes curvature of surface represented by the control points[][]
	{
		double[] Curvatures = new double[2];
		Point3d ru,rv,ruu,rvv,ruv,n;/*n is the vector which is denoted by "n" in									http://power2.fsv.cvut.cz/~dr/papers/Thesis/node11.html.*/
		double ruX=0.0, ruY=0.0, ruZ=0.0;
		double ruuX=0.0, ruuY=0.0, ruuZ=0.0;
		double rvX=0.0, rvY=0.0, rvZ=0.0;
		double rvvX=0.0, rvvY=0.0, rvvZ=0.0;
		double ruvX=0.0, ruvY=0.0, ruvZ=0.0;
		double E,F,G,L,M,N;
		double Aquad, Bquad, Cquad,Dquad;//first 3 are coefficients of the quadratic equation of which the roots are the curvatures. Fourth is the discriminant of the same equation
		int i,j;
		for(i=0;i<numCtrlPointsRow;i++)
                  for(j=0;j<numCtrlPointsCol;j++)
                  {
                    ruX += ctrlPoints[i][j].getx()*dRdu(numCtrlPointsRow,numCtrlPointsCol,i,j,u,v);
                    ruY += ctrlPoints[i][j].gety()*dRdu(numCtrlPointsRow,numCtrlPointsCol,i,j,u,v);
                    ruZ += ctrlPoints[i][j].getz()*dRdu(numCtrlPointsRow,numCtrlPointsCol,i,j,u,v);

                    ruuX += ctrlPoints[i][j].getx()*d2Rdu2(numCtrlPointsRow,numCtrlPointsCol,i,j,u,v);
                    ruuY += ctrlPoints[i][j].gety()*d2Rdu2(numCtrlPointsRow,numCtrlPointsCol,i,j,u,v);
                    ruuZ += ctrlPoints[i][j].getz()*d2Rdu2(numCtrlPointsRow,numCtrlPointsCol,i,j,u,v);

                    rvX += ctrlPoints[i][j].getx()*dRdv(numCtrlPointsRow,numCtrlPointsCol,i,j,u,v);
                    rvY += ctrlPoints[i][j].gety()*dRdv(numCtrlPointsRow,numCtrlPointsCol,i,j,u,v);
                    rvZ += ctrlPoints[i][j].getz()*dRdv(numCtrlPointsRow,numCtrlPointsCol,i,j,u,v);

                    rvvX += ctrlPoints[i][j].getx()*d2Rdv2(numCtrlPointsRow,numCtrlPointsCol,i,j,u,v);
                    rvvY += ctrlPoints[i][j].gety()*d2Rdv2(numCtrlPointsRow,numCtrlPointsCol,i,j,u,v);
                    rvvZ += ctrlPoints[i][j].getz()*d2Rdv2(numCtrlPointsRow,numCtrlPointsCol,i,j,u,v);

                    ruvX += ctrlPoints[i][j].getx()*d2Rdudv(numCtrlPointsRow,numCtrlPointsCol,i,j,u,v);
                    ruvY += ctrlPoints[i][j].gety()*d2Rdudv(numCtrlPointsRow,numCtrlPointsCol,i,j,u,v);
                    ruvZ += ctrlPoints[i][j].getz()*d2Rdudv(numCtrlPointsRow,numCtrlPointsCol,i,j,u,v);
                  }

		ru = new Point3d(ruX,ruY,ruZ);
		rv = new Point3d(rvX,rvY,rvZ);
		ruu = new Point3d(ruuX,ruuY,ruuZ);
		rvv = new Point3d(rvvX,rvvY,rvvZ);
		ruv = new Point3d(ruvX,ruvY,ruvZ);
		E = dotP(ru,ru);
		F = dotP(ru,rv);
		G = dotP(rv,rv);
		n = scalarP(crossP(ru,rv), Math.sqrt(E*G - F*F));
		L = dotP(ruu,n);
		M = dotP(ruv,n);
		N = dotP(rvv,n);

		Aquad = (E*G - F*F);
		Bquad = 2*F*M - E*N - G*L;
		Cquad = L*N - M*M;
		Dquad = Bquad*Bquad - 4*Aquad*Cquad;

		Curvatures[0] = ((-1)*Bquad + Math.sqrt(Dquad)) / (2*Aquad);
		Curvatures[1] = ((-1)*Bquad - Math.sqrt(Dquad)) / (2*Aquad);

		return Curvatures;
	}

	public static double dRdu(int n, int m, int i, int j, double u, double v)
	{
		double sumBB=0.0, sumdBduB=0.0, output;
		double Iterm, IIterm;
		int k,l;//loop variables
		for(k=0;k<n;k++)
			for(l=0;l<m;l++)
				sumBB += B(n,k,u) * B(m,l,v);

		for(k=0;k<n;k++)
			for(l=0;l<m;l++)
				sumdBduB += dBdt(n,k,u) * B(m,l,v);

		Iterm = dBdt(n,i,u) * B(m,j,v) * sumBB;
		IIterm = (-1) * B(n,i,u) * B(m,j,v) * sumdBduB;
		//output = (dBdt(n,i,u)*B(m,j,v)*sumBB - B(n,i,u)*B(m,j,v)*sumdBduB) / (sumBB * sumBB);
		output = (Iterm + IIterm) / (sumBB * sumBB);
		return output;
	}


	public static double dRdv(int n, int m, int i, int j, double u, double v)
	{
		double sumBB=0.0, sumBdBdv=0.0, output;
		double Iterm, IIterm;
		int k,l;//loop variables
		for(k=0;k<n;k++)
			for(l=0;l<m;l++)
				sumBB += B(n,k,u) * B(m,l,v);

		for(k=0;k<n;k++)
			for(l=0;l<m;l++)
				sumBdBdv += B(n,k,u) * dBdt(m,l,v);
		Iterm = B(n,i,u) * dBdt(m,j,v) * sumBB;
		IIterm = (-1) * B(n,i,u) * B(m,j,v) * sumBdBdv;
		//output = (B(n,i,u)*dBdt(m,j,v)*sumBB - B(n,i,u)*B(m,j,v)*sumBdBdv) / (sumBB * sumBB);
		output = (Iterm + IIterm) / (sumBB * sumBB);
		return output;
	}

	public static double d2Rdu2(int n, int m, int i, int j, double u, double v)
	{
		double sumBB=0.0, sumdBduB=0.0, sumd2Bdu2B=0.0, output;
		double Iterm, IIterm, IIIterm;
		int k,l;//loop variables
		for(k=0;k<n;k++)
			for(l=0;l<m;l++)
				sumBB += B(n,k,u) * B(m,l,v);

		for(k=0;k<n;k++)
			for(l=0;l<m;l++)
				sumdBduB += dBdt(n,k,u) * B(m,l,v);

		for(k=0;k<n;k++)
			for(l=0;l<m;l++)
				sumd2Bdu2B += d2Bdt2(n,k,u) * B(m,l,v);

		Iterm = d2Bdt2(n,i,u)*B(m,j,v)*sumBB;
		IIterm = (-1) * 2 * dRdu(n,m,i,j,u,v) * sumBB * sumdBduB;
		IIIterm = (-1) * B(n,i,u) * B(m,j,v) * sumd2Bdu2B;
		//output = (d2Bdt2(n,i,u)*B(m,j,v)*sumBB - 2*dRdu(n,m,i,j,u,v)*sumBB*sumdBduB - B(n,i,u)*B(m,j,v)*sumd2Bdu2B)/ (sumBB * sumBB);
		output = (Iterm + IIterm + IIIterm) / (sumBB * sumBB);
		return output;
	}

	public static double d2Rdv2(int n, int m, int i, int j, double u, double v)
	{
		double sumBB=0.0, sumBdBdv=0.0, sumBd2Bdv2=0.0, output;
		double Iterm, IIterm, IIIterm;
		int k,l;//loop variables
		for(k=0;k<n;k++)
			for(l=0;l<m;l++)
				sumBB += B(n,k,u) * B(m,l,v);

		for(k=0;k<n;k++)
			for(l=0;l<m;l++)
				sumBdBdv += B(n,k,u) * dBdt(m,l,v);

		for(k=0;k<n;k++)
			for(l=0;l<m;l++)
				sumBd2Bdv2 += B(n,k,u) * d2Bdt2(m,l,v);

		Iterm = B(n,i,u) * d2Bdt2(m,j,v) * sumBB;
		IIterm = (-1) * 2 * dRdv(n,m,i,j,u,v) * sumBB * sumBdBdv;
		IIIterm = (-1) * B(n,i,u) * B(m,j,v) * sumBd2Bdv2;
		//output = (B(n,i,u)*d2Bdt2(m,j,v)*sumBB - 2*dRdv(n,m,i,j,u,v)*sumBB*sumBdBdv - B(n,i,u)*B(m,j,v)*sumBd2Bdv2)/ (sumBB * sumBB);
		output = (Iterm + IIterm + IIIterm) / (sumBB * sumBB);
		return output;
	}

	public static double d2Rdudv(int n, int m, int i, int j, double u, double v)
	{
		double sumBB=0.0, sumBdBdv=0.0, sumBd2Bdv2=0.0, sumdBduB=0.0, sumdBdudBdv = 0.0, output;
		double Iterm, IIterm, IIIterm, IVterm, Vterm;
		int k,l;//loop variables

		for(k=0;k<n;k++)
			for(l=0;l<m;l++)
				sumBB += B(n,k,u) * B(m,l,v);

		for(k=0;k<n;k++)
			for(l=0;l<m;l++)
				sumBdBdv += B(n,k,u) * dBdt(m,l,v);

		for(k=0;k<n;k++)
			for(l=0;l<m;l++)
				sumdBduB += dBdt(n,k,u) * B(m,l,v);

		for(k=0;k<n;k++)
			for(l=0;l<m;l++)
				sumdBdudBdv += dBdt(n,k,u) * dBdt(m,l,v);

		Iterm = dBdt(n,i,u) * dBdt(m,j,v) * sumBB;
		IIterm = dBdt(n,i,u) * B(m,j,v) * sumBdBdv;
		IIIterm = (-2) * dRdu(n,m,i,j,u,v) * sumBB * sumBdBdv;
		IVterm = (-1) * B(n,i,u) * dBdt(m,j,v) * sumdBduB;
		Vterm = (-1) * B(n,i,u) * B(m,j,v) * sumdBdudBdv;
		output = (Iterm + IIterm + IIIterm + IVterm + Vterm) / (sumBB * sumBB);
		return output;
	}



	public static double B(int n, int i, double t) //bernstein polynomial, $B_i^n$
	{
		double output = comb(n,i) * exp(t,i) * exp((1-t),n-i);
		return output;
	}

	public static double dBdt(int n, int i, double t) //differentiation w.r.t. t of bernstein polynomial, $d(B_i^n)/dt$
	{
		double Iterm, IIterm,output;
		Iterm = comb(n,i) * i * exp(t,i-1) * exp(1-t,n-i);
		IIterm = comb(n,i) * (-1) * (n-i) * exp(1-t,n-i-1) * exp(t,i);
		/*output = (factorial(n) / (factorial(n-i) * factorial(i))) *
						(i*exp(t,i-1)*exp(1-t,n-i) - (n-i)*exp(1-t,n-i-1)*exp(t,i));*/
		output = Iterm + IIterm;
		return output;
	}

	public static double d2Bdt2(int n, int i, double t) /*second differentiation w.r.t. t of bernstein
																	polynomial, $d^2(B_i^n)/dt^2$ */
	{
		double Iterm, IIterm, IIIterm, IVterm, output;
		Iterm = comb(n,i) * i * (i-1) * exp(t,i-2) * exp(1-t,n-i);
		IIterm = comb(n,i) * (-1) * i * (n-i) * exp(1-t,n-i-1) * exp(t,i-1);
		IIIterm = comb(n,i) * (-1) * (n-i) * i * exp(1-t,n-i-1) * exp(t,i-1);
		IVterm = comb(n,i) * (n-i) * (n-i-1) * exp(t,i) * exp(1-t,n-i-2);
		output = Iterm + IIterm + IIIterm + IVterm;
		/*output = ((factorial(n) / (factorial(n-i) * factorial(i))) *
							(i*(i-1)*exp(t,i-2)*exp(1-t,n-i) - i*(n-i)*exp(1-t,n-i-1)*exp(t,i-1) -
									(n-i)*i*exp(1-t,n-i-1)*exp(t,i-1) + (n-i)*(n-i-1)*exp(t,i)*exp(1-t,n-i-2)
							)
						)*/
		return output;
	}

	public static double dRdt(int n, int i, double t) /* $\frac{dR_i^n(t)}{dt}$, as defined in
										http://power2.fsv.cvut.cz/~dr/papers/Thesis/node11.html*/
	{

    double output,Isum=0.0,IIsum=0.0;
		int j;

		for(j=0; j<=n;j++){
			Isum+=B(n,j,t);}


		for(j=0; j<=n;j++){
			IIsum+=dBdt(n,j,t);}

		output = (dBdt(n,i,t)*Isum - B(n,i,t)*IIsum) / exp(Isum,2);
		return output;
	}

	public static double d2Rdt2(int n, int i, double t) /* $\frac{d^2R_i^n(t)}{dt^2}$, as defined in
											http://power2.fsv.cvut.cz/~dr/papers/Thesis/node11.html*/
	{
		double sumB=0.0, sumdB=0.0, sumd2B=0.0, output;
		int j;

		for(j=0; j<=n;j++) {
			sumB += B(n,j,t);}

		for(j=0; j<=n;j++){
			sumdB += dBdt(n,j,t);}

		for(j=0; j<=n;j++){
			sumd2B += d2Bdt2(n,j,t);}

		output = (d2Bdt2(n,i,t)*sumB - B(n,i,t)*sumd2B - 2*dRdt(n,i,t)*sumdB*sumB) / exp(sumB,2);
		return output;
	}

	public static long factorial(long x)
	{
		int output = 1;
		for (int i = 1; i <= x; i++) {
			output = output * i;
		}
		return output;
		/*if(x < 0) { throw new IllegalArgumentException("Argument less than zero"); }
		 return (x <= 1) ? 1 : (x * factorial(x-1));
		 */
	}

	public static double exp(double base, int pow) /*gives wrong result (=1.0) for pow < 0. Doesn't matter in this
										program, because whenever exponent is negative, the coefficient is zero */
	{
		double output = 1.0;
		for(int i=0;i<pow;i++)
		{
			output = output * base;
		}
		return output;
	}

	public static long comb(int n, int i)
	{
		return (factorial(n) / (factorial(n-i) * factorial(i)));
	}

	public static double dotP(Point3d p1, Point3d p2)
	{
		return p1.getx()*p2.getx() + p1.gety()*p2.gety() + p1.getz()*p2.getz();
	}

	public static Point3d crossP(Point3d p1, Point3d p2)
	{
		Point3d newPoint = new Point3d( (p1.gety()*p2.getz() - p2.gety()*p1.getz()),
										(p2.getx()*p1.getz() - p1.getx()*p2.getz()),
										(p1.getx()*p2.gety() - p2.getx()*p1.gety()));
		return newPoint;
	}

	public static Point3d scalarP(Point3d p, double scalar)
	{
		Point3d newPoint = new Point3d(scalar*p.getx(), scalar*p.gety(), scalar*p.getz());
		return newPoint;
	}
}
