package jmodeler;

import javax.swing.*;
import java.awt.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;

/**
 * <p>Title: jModeler</p>
 * <p>Description: Create and View Bezier curves and surfaces</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: Computer Aided Graphics Design</p>
 * @author (biswarup, chiragp, devesh, dharm, vikasj, jikku)@cse.iitb.ac.in
 * @version 1.0
 */

public class settingsFrame extends JFrame {

  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JButton jButton1 = new JButton();
  JButton jButton2 = new JButton();
  JPanel jPanel2 = new JPanel();
  JPanel jPanel3 = new JPanel();
  JPanel jPanel4 = new JPanel();
  VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();
  JLabel zoom = new JLabel();
  JPanel jPanel5 = new JPanel();
  JLabel jLabel2 = new JLabel();
  JSpinner maxRangeSpinner = new JSpinner();
  JSpinner minRangeSpinner = new JSpinner();
  JPanel jPanel6 = new JPanel();
  JLabel jLabel1 = new JLabel();
  JSpinner zoomStepSpinner = new JSpinner();
  Viewer viewer = null;
  //SpinnerModel sModel = new SpinnerNumberModel(0.10,0.00,1.00,0.05);
  SpinnerModel zoomStepModel = new SpinnerNumberModel(0.10,0.00,5.00,0.1);
  SpinnerModel maxRangeModel = new SpinnerNumberModel(40.0,12.0,60.0,1.0);
  SpinnerModel minRangeModel = new SpinnerNumberModel(1.0,1.0,20.0,1.0);
  SpinnerModel mouseSenseModel = new SpinnerNumberModel(0.1,0.0,5.0,0.1);
  JPanel jPanel7 = new JPanel();
  JLabel jLabel3 = new JLabel();
  JSpinner mouseSenseSpin = new JSpinner();



  public settingsFrame(Viewer v) {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    this.viewer = v;
    zoomStepModel.setValue(new Double(v.zoomStep));
    maxRangeModel.setValue(new Double(v.rangeMax));
    minRangeModel.setValue(new Double(v.rangeMin));
    mouseSenseModel.setValue(new Double(v.rotateStep));
  }

  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    jButton1.setText("Cancel");
    jButton1.addActionListener(new settingsFrame_jButton1_actionAdapter(this));
    jButton2.setText("Ok");
    jButton2.addActionListener(new settingsFrame_jButton2_actionAdapter(this));
    jPanel2.setLayout(verticalFlowLayout1);
    zoom.setText("Max Zoom Range");
    jLabel2.setText("Min Zoom Range");
    jPanel2.setAlignmentY((float) 0.5);
    maxRangeSpinner.setToolTipText("");
    jLabel1.setText("Zoom Step");
    jLabel3.setRequestFocusEnabled(true);
    jLabel3.setText("Mouse Sensitivity");
    this.getContentPane().add(jPanel1,  BorderLayout.SOUTH);
    jPanel1.add(jButton2, null);
    jPanel1.add(jButton1, null);
    this.getContentPane().add(jPanel2, BorderLayout.CENTER);
    jPanel2.add(jPanel3, null);
    jPanel3.add(zoom, null);
    jPanel2.add(jPanel4, null);
    jPanel2.add(jPanel5, null);
    jPanel5.add(jLabel2, null);

    maxRangeSpinner.setModel(maxRangeModel);
    maxRangeSpinner.setPreferredSize(new Dimension(50,20));
    maxRangeSpinner.setVerifyInputWhenFocusTarget(true);


    jPanel3.add(maxRangeSpinner, null);

    minRangeSpinner.setModel(minRangeModel);
    minRangeSpinner.setPreferredSize(new Dimension(50,20));
    minRangeSpinner.setVerifyInputWhenFocusTarget(true);


    jPanel5.add(minRangeSpinner, null);
    jPanel2.add(jPanel6, null);
    jPanel6.add(jLabel1, null);
    zoomStepSpinner.setModel(zoomStepModel);
    zoomStepSpinner.setPreferredSize(new Dimension(50, 20));
    zoomStepSpinner.setVerifyInputWhenFocusTarget(true);
    jPanel6.add(zoomStepSpinner, null);
    jPanel2.add(jPanel7, null);
    jPanel7.add(jLabel3, null);
    jPanel7.add(mouseSenseSpin, null);
    mouseSenseSpin.setModel(mouseSenseModel);
    mouseSenseSpin.setPreferredSize(new Dimension(50,20));
    mouseSenseSpin.setVerifyInputWhenFocusTarget(true);

    this.setTitle("Settings");
  }

  void jButton2_actionPerformed(ActionEvent e) {
    //viewer.setZoomStep((Double)jSpinner3.getValue());
    viewer.setZoomStep(((Double)zoomStepSpinner.getValue()).doubleValue());
    viewer.setRangeMax(((Double)maxRangeSpinner.getValue()).doubleValue());
    viewer.setRangeMin(((Double)minRangeSpinner.getValue()).doubleValue());
    viewer.setMouseSense(((Double)mouseSenseSpin.getValue()).doubleValue());
    this.setVisible(false);
  }

  void jButton1_actionPerformed(ActionEvent e) {
this.setVisible(false);

  }
}

class settingsFrame_jButton2_actionAdapter implements java.awt.event.ActionListener {
  settingsFrame adaptee;

  settingsFrame_jButton2_actionAdapter(settingsFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton2_actionPerformed(e);
  }
}

class settingsFrame_jButton1_actionAdapter implements java.awt.event.ActionListener {
  settingsFrame adaptee;

  settingsFrame_jButton1_actionAdapter(settingsFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton1_actionPerformed(e);
  }
}
